import logging

from config import *

logger = logging.getLogger(PROJECTNAME)

from Products.CMFCore.utils import ContentInit
from Products.CMFCore.DirectoryView import registerDirectory

registerDirectory(SKINS_DIR,GLOBALS)

from Products.ATContentTypes.config import HAS_LINGUA_PLONE
if HAS_LINGUA_PLONE:
    from Products.LinguaPlone.public import process_types
    from Products.LinguaPlone.public import listTypes
else:
    from Products.Archetypes.public import process_types
    from Products.Archetypes.public import listTypes

def initialize(context):
    import contents

    listOfTypes = listTypes(PROJECTNAME)

    content_types, constructors, ftis = process_types(
        listOfTypes,
        PROJECTNAME)

    ContentInit(
        PROJECTNAME,
        content_types      = content_types,
        permission         = 'Add portal contents',
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)
