# -*- coding: utf-8 -*-
from Products.ATContentTypes.content.base import registerATCT
from Products.ATContentTypes.content.document import ATDocument
from Products.ATContentTypes.content.image import ATImage
from Products.DataGridField import DataGridField, DataGridWidget, Column
from Products.Archetypes.public import *

from Products.LetsPay.config import PROJECTNAME

CartSchema = Schema((
        DataGridField('details',
            columns=('reference','name','price'),                
            widget = DataGridWidget(
                columns={
                    'reference':Column('Reference',label_msgid='reference'),
                    'name':Column('Short name',label_msgid='name'),
                    'price':Column('Price',label_msgid='price'),
                },
                i18n_domain='letspay',
                visible={'view':'invisible','edit':'visible'},
                )),
        ))

class CartContent(object):

    def getReference(self,option):
        return self.getDetails()[option]['reference']

    def getName(self,option):
        return self.getDetails()[option]['name']

    def getPrice(self,option):
        return float(self.getDetails()[option]['price'])

class CartDocument(ATDocument, CartContent):

    schema = ATDocument.schema.copy() + CartSchema.copy()

    content_icon   = 'document_icon.gif'
    meta_type = portal_type = archetype_name = 'CartDocument'
    default_view   = 'cartdocument_view'
    immediate_view = 'cartdocument_view'
    suppl_views    = ()

registerATCT(CartDocument, PROJECTNAME)

class CartImage(ATImage, CartContent):

    schema = ATImage.schema.copy() + CartSchema.copy()

    content_icon   = 'image_icon.gif'
    meta_type = portal_type = archetype_name = 'CartImage'
    default_view   = 'cartimage_view'
    immediate_view = 'cartimage_view'
    suppl_views    = ()

registerATCT(CartImage, PROJECTNAME)
