# -*- coding: utf-8 -*-
from zope.component import getUtility
from Products.Five import BrowserView

from Products.LetsPay.z3.cart.interfaces import ICartManager

class CartView(BrowserView):

    def __init__(self,context,request):
        self.context = context
        self.request = request
        self.manager = getUtility(ICartManager)

    def nextURL(self):
        return self.request.RESPONSE.redirect(
                self.context.absolute_url() + '/letspay'
                )

    def getItems(self):
        id = self.request.SESSION.id
        cart = self.manager.getCart(id)
        return cart.getItems()

    def getAmount(self):
        id = self.request.SESSION.id
        cart = self.manager.getCart(id)
        return cart.getAmount()

    def delItem(self):
        id = self.request.SESSION.id
        reference = self.request.get('id')
        cart = self.manager.getCart(id)
        cart.delReference(reference)
        self.manager.setCart(cart)
        return self.nextURL()

    def clearItems(self):
        id = self.request.SESSION.id
        cart = self.manager.getCart(id)
        cart.clearItems()
        self.manager.setCart(cart)
        return self.nextURL()

