# -*- coding: utf-8 -*-
import operator
from interfaces import ICart, ICartItem

class Cart(object):

    def __init__(self,id):
        self.id = id
        self.data = {}

    def getItems(self):
        return [dict(d,amount='%.2f' % float(d['quantity'] * d['price'])) \
                for d in self.data.values()]

    def getAmount(self):
        values = [float(d['quantity'] * d['price']) for d in self.data.values()]
        return '%.2f' % reduce(operator.add,values)

    def clearItems(self):
        self.data = {}

    def addItem(self,obj,quantity,**kwargs):
        item = ICartItem(obj,None)
        if not item:
            return False
        id = item.getReference(**kwargs)
        if self.data.has_key(id):
            quantity = quantity + self.data[id]['quantity']
        self.data[id] = {
                'id':id,
                'name':item.getName(**kwargs),
                'quantity':quantity,
                'price':item.getPrice(**kwargs),
                'url':'%s/view' % item.absolute_url()
                }
        return True

    def addReference(self,reference,quantity):
        if self.data.has_key(reference):
            new = self.data[reference]['quantity'] + quantity
            self.data[reference]['quantity'] = new

    def delReference(self,reference):
        if self.data.has_key(reference):
            del self.data[reference]
