# -*- coding: utf-8 -*-
from zope.component import getUtility

from Products.Five import BrowserView
from Products.LetsPay.z3.cart.interfaces import ICartManager

import config


class PaypalForm(BrowserView):

    def __init__(self,context,request):
        self.context = context
        self.request = request
        try:
            from Products.CMFCore.utils import getToolByName
            self.url = getToolByName(self.context,'portal_url')()
        except:
            self.url = self.context.absolute_url()

    def paypal_url(self):
        return config.paypal_url

    def paypal_account(self):
        return config.paypal_account

    def return_url(self):
        return self.url + '/paypal_ok'

    def cancel_url(self):
        return self.url + '/paypal_cancel'
    
    def currency_code(self):
        return config.currency_code
    
    def notify_url(self):
        return self.url + config.notify_url

    def getItems(self):
        """
        return card items
        """
        id = self.request.SESSION.id
        manager = getUtility(ICartManager)
        cart = manager.getCart(id)
        return cart.getItems()

class PaypalResult(BrowserView):

    def __init__(self,context,request):
        self.context = context
        self.request = request
        self.redirect = self.request.RESPONSE.redirect
        try:
            from Products.CMFCore.utils import getToolByName
            utool = getToolByName(self.context,'portal_url')
            self.url = utool.getPortalObject().absolute_url()
        except:
            self.url = self.context.absolute_url()

    def ok(self):
        """
        return from paypal
        """
        id = self.request.SESSION.id
        manager = getUtility(ICartManager)
        cart = manager.getCart(id)
        items = cart.clearItems()
        manager.setCart(cart)
        return self.redirect(self.url + '/payment_ok')

    def cancel(self):
        """
        return from paypal
        """
        return self.redirect(self.url + '/payment_cancel')

